100 init
110 continuous_loop
120 :
130 DEFine PROCedure init
140 REMark initialise some global vars & load sprites
150   icons%=4          : REMark there are 4 icons
160   OPEN#0,"con"
170   buffer=0          : REMark buffer for prest/psave, unallocated as yet
180   DIM spad(5)       : REMark addresses of sprites
190   ysize%=90        : REMark y size of wdw
200   colour%=-29597    : REMark  %1000110001100011
210   colour%=-28540    : REMark  %1001000010000100
220   colour%=-25369    : REMark  %1001110011100111
230   sprites_dir$=HOME_DIR$ : REMark directory where the sprites are located
240   load_sprites
250   DIM origins%(icons%,4): REMark this will contain the sprite start & end coordinates  (absolute for x,rel for y)
260   distance%=100     : REMark distance from one icon to the next
270   calculate_coords  : REMark fill in the origins array
280   trigger%=ysize%   : REMark  distance, in pixels, from the bottom of the screen that will cause the wdw to pop up.
290 END DEFine init
300 :
310 DEFine PROCedure sa
320   SAVE_O dock_bas
330 END DEFine sa
340 :
350 DEFine PROCedure show_window
360 LOCal lp%,xs%,ys%,xo%,yo
370   OUTLN#0,SCR_XLIM,ysize%,0,SCR_YLIM-ysize%
380   WINDOW#0,SCR_XLIM,ysize%,0,SCR_YLIM-ysize%
390   save_scr ysize%
400   xs%=SCR_XLIM:ys%=1
410   xo%=0:yo%=ysize%-1
420   FOR lp%=0 TO ysize%-1
430     WM_BLOCK#0,xs%,ys%,xo%,yo%,colour%
440     xs%=xs%-2               : REMark draw the "board"
450     xo%=xo%+1
460     yo%=yo%-1
470   END FOR lp%
480   paint_sprites             : REMark show the sprites
490   read_pointer
500   restore_scr ysize%
510 END DEFine show_window
520 :
530 DEFine PROCedure load_sprites
540 REMark load sprites called icon1.spr to icon4.spr from the sperites_dir$
550 LOCal lp%
560   FOR lp%=1 TO icons%
570     spad(lp%-1)=ALCHP(20000)
580     LBYTES sprites_dir$&"icon"&lp%&"_spr",spad(lp%-1)
590   END FOR lp%
600 END DEFine load_sprites
610 :
620 DEFine PROCedure paint_sprites
630 REMark writes the sprites to the screen
640 LOCal lp%,xo%,yo%,dist%
650   FOR lp%=0 TO icons%-1
660     WSPRT#0,origins%(lp%,0),origins%(lp%,1),spad(lp%)
670   END FOR lp%
680 END DEFine print_sprites
690 :
700 DEFine PROCedure save_scr (ys%)
710 REMark save screen underneath my window
720    buffer=PSAVE(#0,0;0,0;SCR_XLIM,ys%,0,0,SCR_XLIM,ys%)
730 END DEFine save_scr
740 :
750 DEFine PROCedure restore_scr (ys%)
760 REMark restore screen underneath my window
770   PREST#0,buffer;0,0;SCR_XLIM,ys%;0,0;0
780 END DEFine restore_scr
790 :
800 DEFine PROCedure read_pointer
810 REMark read  pointer until mouse moved or button/key pressed
820 REMark only return to caller if mouse outside of wdw. ESC quits the program.
830 LOCal lp%,term%,xabs%,yabs%,swnum%,xrel%,yrel%,bt$,ylim%
840   ylim%=SCR_YLIM-ysize%
850   REPeat lp%
860      term%=11
870      RPTR #0,xabs%,yabs%,term%,swnum%,xrel%,yrel%,bt$
880      IF yabs%<ylim%:EXIT lp%   : REMark ptr moved out of wdw
890      IF bt$=CHR$(27):QUIT      : REMark ESC hit
900      IF bt$=CHR$(1) OR bt$=CHR$(2):check_icon_action xabs%,yrel%
910     REMark PAUSE 10
920   END REPeat lp%
930 END DEFine read_pointer
940 :
950 DEFine PROCedure wait_for_pointer
960 REMark checks that ptr is in lower part of screen and then leaves
970 LOCal lp%,term%,xabs%,yabs%,swnum%,xrel%,yrel%,bt$
980   OUTLN#0,0,0,0,0,0
990   WINDOW#0,0,0,0,0
1000   REPeat lp%
1010      term%=48
1020      RPTR #0,xabs%,yabs%,term%,swnum%,xrel%,yrel%,bt$
1030      IF yabs%>SCR_YLIM-trigger%:EXIT lp%        : REMark pointer is in lower part of wdw
1040      PAUSE 20                      : REMark sleep a bit
1050   END REPeat lp%
1060 END DEFine wait_for_pointer
1070 :
1080 DEFine PROCedure continuous_loop
1090 LOCal loop%
1100   REPeat loop%
1110     wait_for_pointer               : REMark sleep until pointer in my area
1120     show_window
1130   END REPeat loop%
1140 END DEFine continuous_loop
1150 :
1160 DEFine PROCedure calculate_coords
1170 REMark tihs calculates the start and end coords of the icons
1180 LOCal lp%,xs%,ys%,xo%,yo%
1190   xo%=(SCR_XLIM-icons%*distance%)/2: REMark center sprites
1200   yo%=4
1210   FOR lp%=0 TO icons%-1
1220     xs%=PEEK_W(spad(lp%)+4)        : REMark sprite x size
1230     ys%=PEEK_W(spad(lp%)+6)        : REMark sprite y size
1240     origins%(lp%,0)=xo%            : REMark x origin of sprite
1250     origins%(lp%,1)=yo%            : REMark y origin of sprite
1260     origins%(lp%,2)=xo%+xs%        : REMark x end of sprite
1270     origins%(lp%,3)=yo%+ys%        : REMark y end of sprite
1280     xo%=xo%+distance%
1290   END FOR lp%
1300   origins%(3,1)=origins%(3,1)+8
1310   origins%(3,3)=origins%(3,3)+8
1320 END DEFine claculate_coords
1330 :
1340 DEFine PROCedure check_icon_action (xabs%,yrel%)
1350 REMark this checks whether a do or a hit was on a icon.
1360 LOCal lp%
1370   FOR lp%= 0 TO icons%-1
1380     IF xabs%>origins%(lp%,0) AND xabs%<origins%(lp%,2)
1390        IF yrel%>origins%(lp%,1) AND yrel%<origins%(lp%,3)
1400           act_on_icon_clicked lp% :EXIT lp%
1410        END IF
1420     END IF
1430   END FOR lp%
1440 END DEFine check_icon_action
1450 :
1460 DEFine PROCedure act_on_icon_clicked  (icon_nbr%)
1470 REMark do whatever the icon is supposed to do
1480   SELect ON icon_nbr%
1490       = 0 : HOT_DO ("f")
1500       = 0 : REMark do something
1510       = 0 : REMark do something
1520       = 0 : REMark do something
1530   END SELect
1540 END DEFine act_on_icon_clicked
1550 :
